﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace ExcelExportIssue
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private DataTable CreateDataTable()
        {
            DataTable dtAct = new DataTable();

            dtAct.Columns.Add("Column 1", typeof(long));
            dtAct.Columns.Add("Column 2", typeof(int));
            dtAct.Columns.Add("Column 3", typeof(long));
            dtAct.Columns.Add("Column 4", typeof(string));
            dtAct.Columns.Add("Column 5", typeof(string));
            dtAct.Columns.Add("Column 6", typeof(string));
            dtAct.Columns.Add("Column 7", typeof(string));
            dtAct.Columns.Add("Column 8", typeof(string));

            dtAct.Columns.Add("Column 9", typeof(string));
            dtAct.Columns.Add("Column 10", typeof(string));
            dtAct.Columns.Add("Column 11", typeof(string));

            dtAct.Columns.Add("Column 12", typeof(int));
            dtAct.Columns.Add("Column 13", typeof(double));
            dtAct.Columns.Add("Column 14", typeof(double));

            dtAct.Columns.Add("Column 15", typeof(string));
            dtAct.Columns.Add("Column 16", typeof(string));

            dtAct.Columns.Add("Column 17", typeof(bool));
            dtAct.Columns.Add("Column 18", typeof(string));
            dtAct.Columns.Add("Column 19", typeof(int));
            dtAct.Columns.Add("Column 20", typeof(string));
            dtAct.Columns.Add("Column 21", typeof(string));
            dtAct.Columns.Add("Column 22", typeof(long));
            dtAct.Columns.Add("Column 23", typeof(DateTime));
            dtAct.Columns.Add("Column 24", typeof(string));
            dtAct.Columns.Add("Column 25", typeof(DateTime));
            dtAct.Columns.Add("Column 26", typeof(string));
            dtAct.Columns.Add("Column 27", typeof(long));
            dtAct.Columns.Add("Column 28", typeof(long));
            dtAct.Columns.Add("Column 29", typeof(bool));
            dtAct.Columns.Add("Column 30", typeof(DateTime));
            dtAct.Columns.Add("Column 31", typeof(DateTime));
            dtAct.Columns.Add("Column 32", typeof(DateTime));
            dtAct.Columns.Add("Column 33", typeof(string));
            dtAct.Columns.Add("Column 34", typeof(char));
            dtAct.Columns.Add("Column 35", typeof(string));

            dtAct.Rows.Add(new object[] { "1000", 
                            "1000", "1000", "1000", 
                            "1000", "1000", "1000", "Y", 
                            "1000", "1000", "1000", 
                            "1000", "1000", "1000", 
                            "1000", "1000", 
                            true, 
                            "1000", "1000", 
                            "1000", "1000", "1000", 
                            DateTime.Now, "1000", DateTime.Now, 
                            "1000", "1000", "1000",
                            false, 
                            DateTime.Now, DateTime.Now, DateTime.Now,
                            "Y", "Y", "Y"
                });
            dtAct.Rows.Add(new object[] { "1000", 
                            "1000", "1000", "1000", 
                            "1000", "1000", "1000", "Y", 
                            "1000", "1000", "1000", 
                            "1000", "1000", "1000", 
                            "1000", "1000", 
                            true, 
                            "1000", "1000", 
                            "1000", "1000", "1000", 
                            DateTime.Now, "1000", DateTime.Now, 
                            "1000", "1000", "1000",
                            false, 
                            DateTime.Now, DateTime.Now, DateTime.Now,
                            "Y", "Y", "Y"
                });
            dtAct.Rows.Add(new object[] { "1000", 
                            "1000", "1000", "1000", 
                            "1000", "1000", "1000", "Y", 
                            "1000", "1000", "1000", 
                            "1000", "1000", "1000", 
                            "1000", "1000", 
                            true, 
                            "1000", "1000", 
                            "1000", "1000", "1000", 
                            DateTime.Now, "1000", DateTime.Now, 
                            "1000", "1000", "1000",
                            false, 
                            DateTime.Now, DateTime.Now, DateTime.Now,
                            "Y", "Y", "Y"
                });
            return dtAct;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            dgAccountDescriptions.DataSource = CreateDataTable();
            dgAccountDescriptions.DataBind();

            dgAccountDescriptions.DisplayLayout.UseFixedHeaders = true;
            dgAccountDescriptions.DisplayLayout.Override.FixedHeaderIndicator = FixedHeaderIndicator.Button;
            dgAccountDescriptions.DisplayLayout.Bands[0].Columns[0].Header.Fixed = true;
            dgAccountDescriptions.DisplayLayout.Bands[0].Columns[1].Header.Fixed = true;
            dgAccountDescriptions.DisplayLayout.Bands[0].Columns[2].Header.Fixed = true;
            dgAccountDescriptions.DisplayLayout.Bands[0].Columns["Column 27"].Hidden = true;

            for (int i = 0; i < dgAccountDescriptions.DisplayLayout.Bands[0].Columns.Count; i++)
            {
                dgAccountDescriptions.DisplayLayout.Bands[0].Columns[i].CellActivation = Activation.ActivateOnly;
                dgAccountDescriptions.DisplayLayout.Bands[0].Columns[i].CellAppearance.BackColor = Color.Silver;
            }
            dgAccountDescriptions.DisplayLayout.Bands[0].Columns[2].CellActivation = Activation.AllowEdit;
            dgAccountDescriptions.DisplayLayout.Bands[0].Columns[2].CellAppearance.BackColor = Color.Empty;
        }

        private void btnExcel_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            DialogResult dr;
            saveFileDialog1.Filter = "Microsoft 97-2003 Workbook|*.xls";
            Infragistics.Win.UltraWinGrid.ExcelExport.UltraGridExcelExporter excelExporter = new Infragistics.Win.UltraWinGrid.ExcelExport.UltraGridExcelExporter();
            excelExporter.BeginExport += new Infragistics.Win.UltraWinGrid.ExcelExport.BeginExportEventHandler(excelExporter_BeginExport);
            dr = saveFileDialog1.ShowDialog();
            if (dr == DialogResult.OK)
            {
                if (!String.IsNullOrEmpty(saveFileDialog1.FileName))
                {
                    try
                    {
                        this.Cursor = Cursors.WaitCursor;
                        excelExporter.Export(dgAccountDescriptions, saveFileDialog1.FileName);
                        MessageBox.Show("Export Successful", "My Application", MessageBoxButtons.OK, MessageBoxIcon.Information, MessageBoxDefaultButton.Button1);
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show(ex.Message);
                    }
                    finally
                    {
                        this.Cursor = Cursors.Default;
                    }
                }
            }
        }

        void excelExporter_BeginExport(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.BeginExportEventArgs e)
        {
            e.Layout.UseFixedHeaders = false;
            foreach (Infragistics.Win.UltraWinGrid.UltraGridBand band in e.Layout.Bands)
            {
                foreach (Infragistics.Win.UltraWinGrid.UltraGridColumn column in band.Columns)
                {
                    if (column.Key.Equals("Column 27"))
                    {
                        column.Hidden = true;
                    }
                    else
                    {
                        column.Hidden = false;
                    }
                    column.PerformAutoResize(PerformAutoSizeType.AllRowsInBand, true);
                }
            }
        }
    }
}
